#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

import numpy
import random

class types:
    SEM = 0,
    I = 1,
    J = 2,
    L = 3,
    O = 4,
    S = 5,
    T = 6,
    Z = 7

SEM = numpy.array(
    (
    (0, 0, 0, 0),
    (0, 1, 0, 0),
    (0, 0, 0, 0),
    (0, 0, 0, 0)
    )
)

SEM_ROTATION = [SEM]

O = numpy.array(
    (
    (0, 0, 0, 0),
    (0, 1, 1, 0),
    (0, 1, 1, 0),
    (0, 0, 0, 0)
    )
)

O_ROTATION = [O]

I = numpy.array(
    (
    (0, 1, 0, 0),
    (0, 1, 0, 0),
    (0, 1, 0, 0),
    (0, 1, 0, 0)
    )
)

I2 = numpy.array(
    (
    (0, 0, 0, 0),
    (1, 1, 1, 1),
    (0, 0, 0, 0),
    (0, 0, 0, 0)
    )
)

I_ROTATION = [I, I2]

J1 = numpy.array(
    (
    (0, 1, 0, 0),
    (0, 1, 0, 0),
    (1, 1, 0, 0),
    (0, 0, 0, 0)
    )
)

J2 = numpy.array(
    (
    (1, 0, 0, 0),
    (1, 1, 1, 0),
    (0, 0, 0, 0),
    (0, 0, 0, 0)
    )
)

J3 = numpy.array(
    (
    (0, 1, 1, 0),
    (0, 1, 0, 0),
    (0, 1, 0, 0),
    (0, 0, 0, 0)
    )
)

J4 = numpy.array(
    (
    (0, 0, 0, 0),
    (1, 1, 1, 0),
    (0, 0, 1, 0),
    (0, 0, 0, 0)
    )
)

J_ROTATION = [J1, J2, J3, J4]

L1 = numpy.array(
    (
    (0, 1, 0, 0),
    (0, 1, 0, 0),
    (0, 1, 1, 0),
    (0, 0, 0, 0)
    )
)

L2 = numpy.array(
    (
    (0, 0, 0, 0),
    (1, 1, 1, 0),
    (1, 0, 0, 0),
    (0, 0, 0, 0)
    )
)

L3 = numpy.array(
    (
    (1, 1, 0, 0),
    (0, 1, 0, 0),
    (0, 1, 0, 0),
    (0, 0, 0, 0)
    )
)

L4 = numpy.array(
    (
    (0, 0, 1, 0),
    (1, 1, 1, 0),
    (0, 0, 0, 0),
    (0, 0, 0, 0)
    )
)

L_ROTATION = [L1, L2, L3, L4]

S1 = numpy.array(
    (
    (0, 0, 0, 0),
    (0, 1, 1, 0),
    (1, 1, 0, 0),
    (0, 0, 0, 0)
    )
)

S2 = numpy.array(
    (
    (0, 1, 0, 0),
    (0, 1, 1, 0),
    (0, 0, 1, 0),
    (0, 0, 0, 0)
    )
)

S_ROTATION = [S1, S2]

Z1 = numpy.array(
    (
    (0, 0, 0, 0),
    (1, 1, 0, 0),
    (0, 1, 1, 0),
    (0, 0, 0, 0)
    )
)

Z2 = numpy.array(
    (
    (0, 1, 0, 0),
    (1, 1, 0, 0),
    (1, 0, 0, 0),
    (0, 0, 0, 0)
    )
)

Z_ROTATION = [Z1, Z2]

T1 = numpy.array(
    (
    (0, 1, 0, 0),
    (1, 1, 1, 0),
    (0, 0, 0, 0),
    (0, 0, 0, 0)
    )
)

T2 = numpy.array(
    (
    (0, 1, 0, 0),
    (0, 1, 1, 0),
    (0, 1, 0, 0),
    (0, 0, 0, 0)
    )
)

T3 = numpy.array(
    (
    (0, 0, 0, 0),
    (1, 1, 1, 0),
    (0, 1, 0, 0),
    (0, 0, 0, 0)
    )
)

T4 = numpy.array(
    (
    (0, 1, 0, 0),
    (1, 1, 0, 0),
    (0, 1, 0, 0),
    (0, 0, 0, 0)
    )
)

T_ROTATION = [T1, T2, T3, T4]

class block:
    
    def __init__(self):
        self.x = 4
        self.y = 2
        self.type = types.SEM
        self.rotation = SEM_ROTATION
        self.irotation = 0

    def CanMutate(self):
        if self.x > 0 and self.x < 9 and self.y < 20:
            return True
        return False

    def ReturnShape(self):
        return self.rotation[self.irotation]

    def Rotate(self):
        if self.irotation + 1 == len(self.rotation):
            self.irotation = 0
        else:
            self.irotation += 1

    def MutateToI(self):
        if self.CanMutate() is not True:
            return
        self.type = types.I
        self.rotation = I_ROTATION;
        self.irotation = 0

    def MutateToO(self):
        if self.CanMutate() is not True:
            return
        self.type = types.O
        self.rotation = O_ROTATION
        self.irotation = 0

    def MutateToJ(self):
        if self.CanMutate() is not True:
            return
        self.type = types.J
        self.rotation = J_ROTATION
        self.irotation = 0

    def MutateToL(self):
        if self.CanMutate() is not True:
            return
        self.type = types.L
        self.rotation = L_ROTATION
        self.irotation = 0

    def MutateToS(self):
        if self.CanMutate() is not True:
            return
        self.type = types.S
        self.rotation = S_ROTATION
        self.irotation = 0

    def MutateToZ(self):
        if self.CanMutate() is not True:
            return
        self.type = types.Z
        self.rotation = Z_ROTATION
        self.irotation = 0

    def MutateToT(self):
        if self.CanMutate() is not True:
            return
        self.type = types.T
        self.rotation = T_ROTATION
        self.irotation = 0
