'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "gamelib"
package.
'''

#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

import pyglet
import data
import engine

drawables = []#list of drawables
OnKeyPress = None
OnKeyRelease = None

def main():
    window = pyglet.window.Window(640, 480, "mutantris")
    
    @window.event
    def on_draw():
        window.clear()
        for adrawable in drawables:
            adrawable.draw()
    
    @window.event
    def on_key_press(symbol, modifiers):
        if OnKeyPress is not None:
            OnKeyPress(symbol, modifiers)
            
    @window.event
    def on_key_release(symbol, modifiers):
        if OnKeyRelease is not None:
            OnKeyRelease(symbol, modifiers)
    
    drawables = engine.theengine.drawables
    pyglet.clock.set_default(engine.theengine.clock)
    OnKeyPress = engine.theengine.OnKeyPress
    pyglet.app.run()
